{-# LANGUAGE NoMonomorphismRestriction #-}

import Diagrams.Backend.SVG.CmdLine
import Diagrams.Prelude

import Data.List
import Data.Maybe

import DC hiding (circle)

drawLeaf :: Colour Double -> Cell -> Diagram B
drawLeaf color ((xmin, ymin), (xmax, ymax)) =
        square (xmax - xmin - 0.005) #
        translate (r2 ((xmin + xmax) / 2, (ymin + ymax) / 2)) #
        lc color # lw 1

tree res = collapse hi $ merge hi $ buildTree (0,0) (1,1) res
draw res = foldTree (tree res)
           ((0,0), (1,1)) (\x -> mempty) (drawLeaf lightgrey) (drawLeaf black) (drawLeaf green)

getContours res = dc hi $ collapse hi $ merge hi $ buildTree (0,0) (1,1) res
getPts res = catMaybes $ foldMap (\x -> [feature hi x]) $ (tree res)

a :: Diagram B
a = mconcat [circle 0.007 # translate (r2 pt) # lc darkred # fc darkred |
             pt <- getPts 5]

outline :: Diagram B
outline =  mconcat [(p2 $ fst pt) ~~ (p2 $ snd pt) | pt <- getContours 5]

main = mainWith $ (outline # lc red <> draw 5) ||| strut unitX # scaleX 0.2 |||
                  (a <> outline # lc red)
