{-# LANGUAGE NoMonomorphismRestriction #-}
import Diagrams.Backend.SVG.CmdLine
import Diagrams.Prelude

import Data.List

import qualified Tree as T
import qualified Dual as D

import Shape (hi)

drawDual :: D.DualCell -> Diagram B
drawDual (a, b, c, d) =
    (p2 a) ~~ (p2 b) <>
    (p2 b) ~~ (p2 d) <>
    (p2 d) ~~ (p2 c) <>
    (p2 c) ~~ (p2 a) <>
    (circle r # translate (r2 a) # fc black) <>
    (circle r # translate (r2 b) # fc black) <>
    (circle r # translate (r2 c) # fc black) <>
    (circle r # translate (r2 d) # fc black)
    where r = 0.005

drawLeaf :: T.Tree -> Diagram B
drawLeaf tree =
    let (a, b, c, d) = T.corners tree
    in (p2 a) ~~ (p2 b) <>
       (p2 b) ~~ (p2 d) <>
       (p2 d) ~~ (p2 c) <>
       (p2 c) ~~ (p2 a)

draw res = (D.foldMapDual drawDual $ T.buildTree hi (0,0) (1,1) res) <>
           ((T.foldTree drawLeaf $ T.buildTree hi (0,0) (1,1) res) # lc lightgrey)

example :: Diagram B
example = draw 5

main = mainWith (example :: Diagram B)
