{-# LANGUAGE NoMonomorphismRestriction #-}
import Diagrams.Backend.SVG.CmdLine
import Diagrams.Prelude

import Data.List
import Data.Maybe

import Types
import Tree
import Dual
import Shape (hi, Shape)
import Deriv

drawDual :: Shape -> DualCell -> Diagram B
drawDual shape (a, b, c, d) =
    (circle r # translate (r2 a) # fc (fc' a) # lc (lc' a)) <>
    (circle r # translate (r2 b) # fc (fc' b) # lc (lc' b)) <>
    (circle r # translate (r2 c) # fc (fc' c) # lc (lc' c)) <>
    (circle r # translate (r2 d) # fc (fc' d) # lc (lc' d)) <>
    (p2 a) ~~ (p2 b) # lc lightgrey <>
    (p2 b) ~~ (p2 d) # lc lightgrey  <>
    (p2 d) ~~ (p2 c) # lc lightgrey  <>
    (p2 c) ~~ (p2 a) # lc lightgrey
    where r = 0.005
          fc' q = (if shape q < 0 then black else white)
          lc' q = (if shape q < 0 then black else lightgrey)

res = 5
dms = splitEdges hi $ dualMarchingSquares hi (0,0) (1,1) res

draw = mconcat [circle 0.005 # translate (r2 d) # fc lightgreen # lc green | d <- nub $ map fst dms] <>
       mconcat [(p2 $ fst e) ~~ (p2 $ snd e) # lc green| e <- dms] <>
        (foldMapDual (drawDual hi) $ buildTree hi (0,0) (1,1) res)



main = mainWith (draw :: Diagram B)

