{-# LANGUAGE NoMonomorphismRestriction #-}
import Diagrams.Backend.SVG.CmdLine
import Diagrams.Prelude

import Data.List
import Data.Maybe

import Types
import Squares (getEdges)
import Shape (hi)
import Deriv

edges = getEdges hi (0,0) (1,1) 21
pts = nub $ concat [[a, b] | (a, b) <- edges]
norms = map (deriv hi) pts

q = zip edges $ map (splitEdge hi) edges
splitEdges = concat $ map (\(a,b) -> [a,b])
                    $ map (fromJust . snd)
                    $ filter (isJust . snd) q
unsplitEdges = map fst $ filter (isNothing . snd) q

drawn :: Diagram B
drawn = mconcat [(p2 $ fst e) ~~ (p2 $ snd e) # lc red # lw 2
                | e <- splitEdges] <>
          mconcat [(p2 $ fst e) ~~ (p2 $ snd e) # lc green # lw 2
                | e <- unsplitEdges]

example :: Diagram B
example = drawn {-(drawn <> mconcat [arrowBetween (p2 $ p) (p2 $ (x + dx/15, y + dy/15)) # lc red # lw 2
            | (p@(x, y), (dx, dy)) <- zip pts norms])
            ||| (strut unitX # scaleX 0.5) ||| drawn
            -}



main = mainWith (example :: Diagram B)
