{-# LANGUAGE NoMonomorphismRestriction #-}
import Diagrams.Backend.SVG.CmdLine
import Diagrams.Prelude

import Data.List

import Types
import Squares (getEdges)
import Shape (hi)
import Deriv

edges = getEdges hi (0,0) (1,1) 21
pts = nub $ concat [[a, b] | (a, b) <- edges]
norms = map (deriv hi) pts

example :: Diagram B
example = mconcat [(p2 $ fst e) ~~ (p2 $ snd e) # lc green # lw 2
                | e <- edges] <>
         mconcat [arrowBetween (p2 $ p) (p2 $ (x + dx/15, y + dy/15)) # lc red # lw 2
            | (p@(x, y), (dx, dy)) <- zip pts norms]

main = mainWith (example :: Diagram B)
