{-# LANGUAGE NoMonomorphismRestriction #-}

import Diagrams.Backend.SVG.CmdLine
import Diagrams.Prelude

import Data.List

import DC

drawLeaf :: Colour Double -> Cell -> Diagram B
drawLeaf color ((xmin, ymin), (xmax, ymax)) =
        square (xmax - xmin - 0.005) #
        translate (r2 ((xmin + xmax) / 2, (ymin + ymax) / 2)) #
        lc color # lw 1

draw res = foldTree (collapse hi $ buildTree (0,0) (1,1) res)
           ((0,0), (1,1)) (\x -> mempty) (drawLeaf lightgrey) (drawLeaf black) (drawLeaf lightgreen)

example :: Diagram B
example = foldr1 (\x y -> x ||| strut unitX # scaleX 0.5 ||| y)
          $ map draw [1..5]

{-
example :: Diagram B
example = draw 5
-}

main = mainWith (example :: Diagram B)
