{-# LANGUAGE NoMonomorphismRestriction #-}

import Diagrams.Backend.SVG.CmdLine
import Diagrams.Prelude

import Data.List

import DC hiding (circle)

drawLeaf :: Colour Double -> Cell -> Diagram B
drawLeaf color ((xmin, ymin), (xmax, ymax)) =
        square (xmax - xmin - 0.005) #
        translate (r2 ((xmin + xmax) / 2, (ymin + ymax) / 2)) #
        lc color # lw 1

draw res = foldTree (collapse hi $ buildTree (0,0) (1,1) res)
           ((0,0), (1,1)) (\x -> mempty) (drawLeaf lightgrey) (drawLeaf black) (drawLeaf green)

getContours res = foldMap (contours hi) $ collapse hi $ buildTree (0,0) (1,1) res

{-
example :: Diagram B
example = foldr1 (\x y -> x ||| strut unitX # scaleX 0.5 ||| y)
          $ map draw [1..5]
-}

outline :: Diagram B
outline =  mconcat [(p2 $ fst pt) ~~ (p2 $ snd pt) | pt <- getContours 5]

a :: Diagram B
a = outline # lc red <> draw 5

b :: Diagram B
b = mconcat [circle 0.005 # translate (r2 d) |
             (_, d) <- getContours 5] # lc darkred # fc darkred
    <> outline # lc red

main = mainWith (a ||| strut unitX # scaleX 0.2 ||| b)
